CREATE SEQUENCE SUB_PRODUCT_ID_SEQ START WITH 1;
CREATE TABLE SUB_PRODUCT (
    ID INTEGER NOT NULL,
    PRODUCT VARCHAR NOT NULL,
    CODE VARCHAR NOT NULL,
    PRICEBUY DOUBLE PRECISION DEFAULT 0 NOT NULL,
    PRICESELL DOUBLE PRECISION DEFAULT 0 NOT NULL,
    QTY DOUBLE PRECISION DEFAULT 1 NOT NULL,
    UOM VARCHAR DEFAULT 'UNIT' NOT NULL,
	ATTRIBUTESET_ID VARCHAR,
	DEFAULT_PURCHASE BOOLEAN DEFAULT FALSE NOT NULL ,
	PRIMARY KEY (ID),
    CONSTRAINT SUB_PRODUCTS_FK_1 FOREIGN KEY (PRODUCT) REFERENCES PRODUCTS(ID),
    CONSTRAINT SUB_PRODUCTS_FK_2 FOREIGN KEY (ATTRIBUTESET_ID) REFERENCES ATTRIBUTESET(ID)
);

CREATE SEQUENCE SUPPLIER_SEQ START WITH 1;
CREATE TABLE SUPPLIER (
  ID INTEGER NOT NULL,
  NAME VARCHAR NOT NULL,
  MOBILE VARCHAR,
  PHONE VARCHAR DEFAULT NULL,
  EMAIL VARCHAR DEFAULT NULL,
  ADDRESS VARCHAR DEFAULT NULL,
  VAT_ID VARCHAR,
  TAXCATEGORY VARCHAR,
  CURCREDIT DOUBLE PRECISION DEFAULT 0,
  PRIMARY KEY (ID),
  CONSTRAINT SUPPLIER_TAXCAT FOREIGN KEY (TAXCATEGORY) REFERENCES TAXCUSTCATEGORIES(ID)
);

CREATE SEQUENCE PURCHASE_ORDER_SEQ START WITH 1;
CREATE SEQUENCE PO_PURCHASE_ORDER_SEQ START WITH 1;
CREATE SEQUENCE PO_REFOUND_PURCHASE_ORDER_SEQ START WITH 1;

CREATE TABLE PURCHASE_ORDER (
  ID INTEGER NOT NULL,
  DATENEW DATE NOT NULL,
  PO_ID INTEGER NOT NULL,
  REFERENCE VARCHAR NOT NULL,
  SUPPLIER INTEGER NOT NULL,
  STATUS INTEGER NOT NULL DEFAULT 0,
  STORE VARCHAR,
  AMOUNT_UNTAX DOUBLE PRECISION DEFAULT 0,
  AMOUNT_TAX DOUBLE PRECISION DEFAULT 0,
  AMOUNT DOUBLE PRECISION DEFAULT 0,
  TOTALPAID DOUBLE PRECISION DEFAULT 0,
  SUPPLIER_VAT_ID VARCHAR,
  REFOUND BOOLEAN DEFAULT FALSE,
  USERID VARCHAR NOT NULL,
  PRIMARY KEY (ID),
  CONSTRAINT PO_SUPPLIER_FK FOREIGN KEY (SUPPLIER) REFERENCES SUPPLIER(ID)
);
CREATE SEQUENCE PURCHASE_ORDER_LINE_SEQ START WITH 1;
CREATE TABLE PURCHASE_ORDER_LINE (
  ID INTEGER NOT NULL DEFAULT nextval('PURCHASE_ORDER_LINE_SEQ'),
  PO INTEGER NOT NULL ,
  PRODUCT VARCHAR NOT NULL ,
  SUBPRODUCT INTEGER ,
  QTY DOUBLE PRECISION NOT NULL  ,
  PRICE DOUBLE PRECISION NOT NULL,
  AMOUNT_TAX DOUBLE PRECISION DEFAULT 0,
  VAUE DOUBLE PRECISION DEFAULT 0,
  TAXID VARCHAR,
  PRIMARY KEY (ID),
  CONSTRAINT POLINE_PO_FK FOREIGN KEY (PO) REFERENCES PURCHASE_ORDER(ID),
  CONSTRAINT POLINE_PO_FK_2 FOREIGN KEY (TAXID) REFERENCES TAXES(ID),
  CONSTRAINT POLINE_PO_FK_3 FOREIGN KEY (SUBPRODUCT) REFERENCES SUB_PRODUCT(ID)
);

CREATE SEQUENCE PURCHASE_PAYMENT_SEQ START WITH 1;
CREATE TABLE PURCHASE_PAYMENT (
  ID INTEGER NOT NULL DEFAULT nextval('PURCHASE_PAYMENT_SEQ'),
  PO INTEGER NOT NULL ,
  TYPE VARCHAR NOT NULL,
  DATE DATE NOT NULL,
  AMOUNT  DOUBLE PRECISION NOT NULL,
  NOTE VARCHAR,
  CONSTRAINT PO_PAYMENT_FK FOREIGN KEY (PO) REFERENCES PURCHASE_ORDER(ID)
);

ALTER TABLE TICKETLINES ADD COLUMN SUBPRODUCT INTEGER;
ALTER TABLE TICKETLINES ADD COLUMN SUBQTY DOUBLE PRECISION NOT NULL DEFAULT 0.0;

UPDATE RESOURCES SET CONTENT=$FILE{/com/openbravo/pos/templates/Menu.Root.txt} WHERE ID='0';
UPDATE ROLES SET PERMISSIONS=$FILE{/com/openbravo/pos/templates/Role.Administrator.xml} WHERE ID='0';
UPDATE ROLES SET PERMISSIONS=$FILE{/com/openbravo/pos/templates/Role.Manager.xml} WHERE ID='1';
UPDATE ROLES SET PERMISSIONS=$FILE{/com/openbravo/pos/templates/Role.Employee.xml} WHERE ID='2';
UPDATE APPLICATIONS SET NAME = $APP_NAME{}, VERSION = $APP_VERSION{} WHERE ID = $APP_ID{};